--	UniTarget by Unique of the Lightning Troopers guild on Dalaran
--	Thanks to Meog, Jooky, Norganna, Sardonic, Woolfeist, Trentin, Zuban, Lemine, Kaitlin & Dizzarian
--      whose code I've blatantly ripped in parts and learnt a lot from :).


UNITARGETVERSION = "0.9";
UNITARGETNAME = "Uni Target";
UNITARGETDESC = "Uni Target mod to allow click or keybind for target info";
UNITARGETFRAME = "UniTargetFrame";
UNITARGETOPTIONSFRAME = "UniTargetConfigFrame";

SLASH_UNITARGET1 = "/UniTarget";
SLASH_UNITARGET2 = "/ut";

UNI_UNITARGETUSAGE_SUBCMD = {};
UNI_UNITARGETUSAGE_SUBCMD[1] = "Usage: (/UniTarget or /ut)";
UNI_UNITARGETUSAGE_SUBCMD[2] = "  |cffffffff/ut target|r - Gives the instructions for the new targetting output side of the mod.";
UNI_UNITARGETUSAGE_SUBCMD[3] = "  |cffffffff/ut button|r - Gives the instructions for button-handling.";
UNI_UNITARGETUSAGE_SUBCMD[4] = "  |cffffffff/ut pvp [|cff66ccffon|off|toggle|cffffffff]|r - Toggles between PvP reporting on/off.";
UNI_UNITARGETUSAGE_SUBCMD[5] = "  |cffffffff/ut style [|cff66ccffbrief|verbose|toggle|cffffffff]|r - Toggles between the style of reporting.";
UNI_UNITARGETUSAGE_SUBCMD[6] = "  |cffffffff/ut guild [|cff66ccffon|off|toggle|cffffffff]|r - Toggles guild-name reporting on/off.";
UNI_UNITARGETUSAGE_SUBCMD[7] = "  |cffffffff/ut race [|cff66ccffon|off|toggle|cffffffff]|r - Toggles race reporting on/off.";
UNI_UNITARGETUSAGE_SUBCMD[8] = "  |cffffffff/ut class [|cff66ccffon|off|toggle|cffffffff]|r - Toggles class reporting on/off.";
UNI_UNITARGETUSAGE_SUBCMD[9] = "  |cffffffff/ut location [|cff66ccffon|off|toggle|cffffffff]|r - Toggles location reporting on/off.";
UNI_UNITARGETUSAGE_SUBCMD[10] = "  |cffffffff/ut status|r - shows the current status of the settings.";
UNI_UNITARGETUSAGE_SUBCMD[11] = "  |cffffffff/ut channel [|cff66ccffself/say/yell/party/guild/raid/1/2/3/4/5|cffffffff]|r - Gives instructions for setting up which channel output.";
UNI_UNITARGETUSAGE_SUBCMD[12] = "  |cffffffff/ut config|r - Displays the config window.";

UNI_UNITARGETBUTTON_SUBCMD = {};
UNI_UNITARGETBUTTON_SUBCMD[1] = "Button Command Usage:";
UNI_UNITARGETBUTTON_SUBCMD[2] = "  |cffffffff/ut button show|r - shows the target button next to the target frame (moveable).";
UNI_UNITARGETBUTTON_SUBCMD[3] = "  |cffffffff/ut button hide|r - hides the target button.";
UNI_UNITARGETBUTTON_SUBCMD[4] = "  |cffffffff/ut button status|r - shows the current status.";
UNI_UNITARGETBUTTON_SUBCMD[5] = "  |cffffffff/ut button lock/unlock|r - locks or unlocks the button.";
UNI_UNITARGETBUTTON_SUBCMD[6] = "  |cffffffff/ut button chatprint|r - toggles whether chatprint as well as insert into edit box.";
UNI_UNITARGETBUTTON_SUBCMD[7] = "  |cffffffff/ut button [large|small|tiny]|r - sets the size to large, small or tiny.";
UNI_UNITARGETBUTTON_SUBCMD[8] = "  |cffffffff/ut button sizetoggle|r - scrolls through the sizes.";
UNI_UNITARGETBUTTON_SUBCMD[9] = "  |cffffffff/ut button tooltips|r - Toggles the tooltips on/off.";
UNI_UNITARGETBUTTON_SUBCMD[10] = "  |cffffffff/ut button function|r - Toggles left/right mousebutton functionality.";

UNI_UNITARGET_SUBCMD = {};
UNI_UNITARGET_SUBCMD[1] = "  Type \'|cffffffff/ut button|r\' to get info on the button info.";
UNI_UNITARGET_SUBCMD[3] = "  Type \'|cffffffff/ut target|r\' to get info on the targetting/keybind info.";
UNI_UNITARGET_SUBCMD[4] = "  \'|cffffffff/ut target self|r\' - Displays target info to your own chatwindow (no broadcast).";
UNI_UNITARGET_SUBCMD[5] = "  \'|cffffffff/ut target guild|r\' - Displays target info to the guild channel.";
UNI_UNITARGET_SUBCMD[6] = "  \'|cffffffff/ut target officer|r\' - Displays target info to the officer channel (if you can see it).";
UNI_UNITARGET_SUBCMD[7] = "  \'|cffffffff/ut target party|r\' - Displays target info to the party channel.";
UNI_UNITARGET_SUBCMD[8] = "  \'|cffffffff/ut target raid|r\' - Displays target info to the raid channel.";
UNI_UNITARGET_SUBCMD[9] = "  \'|cffffffff/ut target config|r\' - Displays target info to the configured channel (\'/ut channel <name>\').";
UNI_UNITARGET_SUBCMD[10] = "  All of these commands are key-bindable under the \'UniHelp Targeting\' section.";


UniTarget_NameRegistered = 0;
UniTargetButtonSizeSmall = 0.8;
UniTargetButtonSizeTiny = 0.5;
UniTarMessage = 0;
UniTarColourMessage = 0;

local UTLang="Common";
local myfaction=UnitFactionGroup("player");
if (UnitFactionGroup("player")=="Horde") then
	UTLang="Orcish";
end

function UniTarget_OnLoad()
	SlashCmdList["UNITARGET"] = function(msg)
		UniTarget_Command(msg);
	end
	
	this:RegisterEvent("VARIABLES_LOADED");
end

function UniTarget_OnEvent()
	if(event == "VARIABLES_LOADED") then
		this:UnregisterEvent("VARIABLES_LOADED");
		if (myAddOnsFrame) then
			myAddOnsList.UniTarget = {
				name = UNITARGETNAME,
				description = UNITARGETDESC,
				version = UNITARGETVERSION,
				category = MYADDONS_CATEGORY_COMBAT,
				frame = UNITARGETFRAME,
				optionsframe = UNITARGETOPTIONSFRAME};
		end
		if (not UniTargetSaved) or (not UniTargetSaved.Version) or (UniTargetSaved.Version < UNITARGETVERSION) then
			UniTargetSaved = { };
			UTDefaultConfig();
			UniTar_ChatPrint("UniTarget Settings reset to default to prevent errors.");
			UIErrorsFrame:AddMessage("UniTarget v"..UNITARGETVERSION.." has loaded.", 1.0, 0.0, 0.0, 1.0, 30);
			if( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage("UniTarget v"..UNITARGETVERSION.." has loaded. \'/ut config\' for setup.", 0.9, 0.25, 1.0);
			end
		end
		if (not UniTargetSaved) then
			UniTargetSaved = { };
			UTDefaultConfig();
		end
		if (UniTargetSaved.Version ~= UNITARGETVERSION) then
			UniTargetSaved.Version = UNITARGETVERSION;
		end
		-- Variable Setup Attempt
		if ((UniTargetSaved["Channel"] == nil) or not (UniTargetSaved["Channel"])) then
			UniTargetSaved["Channel"] = "PARTY";
		end
		if ((UniTargetSaved["Button"] == nil) or not (UniTargetSaved["Button"])) then
			UniTargetSaved["Button"] = 1;
		end
		if ((UniTargetSaved["Chatprint"] == nil) or not (UniTargetSaved["Chatprint"])) then
			UniTargetSaved["Chatprint"] = 0;
		end
		if ((UniTargetSaved["ButtonLock"] == nil) or not (UniTargetSaved["ButtonLock"])) then
			UniTargetSaved["ButtonLock"] = 1;
		end
		if ((UniTargetSaved["ButtonSize"] == nil) or not (UniTargetSaved["ButtonSize"])) then
			UniTargetSaved["ButtonSize"] = "large";
		end
		if ((UniTargetSaved["Version"] == nil) or not (UniTargetSaved["Version"])) then
			UniTargetSaved["Version"] = UNITARGETVERSION;
		end
		if ((UniTargetSaved["PVPReport"] == nil) or not (UniTargetSaved["PVPReport"])) then
			UniTargetSaved["PVPReport"] = 1;
		end
		if ((UniTargetSaved["Style"] == nil) or not (UniTargetSaved["Style"])) then
			UniTargetSaved["Style"] = 1;
		end
		if ((UniTargetSaved["Guild"] == nil) or not (UniTargetSaved["Guild"])) then
			UniTargetSaved["Guild"] = 1;
		end
		if ((UniTargetSaved["Race"] == nil) or not (UniTargetSaved["Race"])) then
			UniTargetSaved["Race"] = 1;
		end
		if ((UniTargetSaved["Location"] == nil) or not (UniTargetSaved["Location"])) then
			UniTargetSaved["Location"] = 1;
		end
		if ((UniTargetSaved["Class"] == nil) or not (UniTargetSaved["Class"])) then
			UniTargetSaved["Class"] = 1;
		end
		if ((UniTargetSaved["Channel"] == nil) or not (UniTargetSaved["Channel"])) then
			UniTargetSaved["Channel"] = "PARTY";
		end
		if ((UniTargetSaved["ButtonTooltips"] == nil) or not (UniTargetSaved["ButtonTooltips"])) then
			UniTargetSaved["ButtonTooltips"] = 1;
		end
		if ((UniTargetSaved["ButtonFunction"] == nil) or not (UniTargetSaved["ButtonFunction"])) then
			UniTargetSaved["ButtonFunction"] = 1;
		end
	end
end

function UTDefaultConfig()
	UniTargetSaved = {};
	UniTargetSaved.Channel = "PARTY";
	UniTargetSaved.Button = 1;
	UniTargetSaved.Chatprint = 0;
	UniTargetSaved.ButtonLock = 1;
	UniTargetSaved.ButtonSize = "large";
	UniTargetSaved.PVPReport = 1;
	UniTargetSaved.Style = 2;
	UniTargetSaved.Guild = 1;
	UniTargetSaved.Race = 1;
	UniTargetSaved.Location = 1;
	UniTargetSaved.Class = 1;
	UniTargetSaved.ButtonTooltips = 1;
	UniTargetSaved.ButtonFunction = 1;
	UniTargetSaved.Version = UNITARGETVERSION;
	UniTargetButton_Reset();
end
------------------------------------------------------------------------------------------------
-- Slash Command
------------------------------------------------------------------------------------------------

function UniTarget_Command(command)
	
	local i,j, cmd, param = string.find(command, "^([^ ]+) (.+)$");
	if (not cmd) then cmd = command; end
	if (not cmd) then cmd = ""; end
	--if (not param) then param = ""; end
	
	if ( cmd and strlen(cmd) > 0 ) then
		cmd = strlower(cmd);
	end
	if ((cmd == "") or (cmd == "help")) then
		UniTar_ChatPrint(">");
		local index, subcmdUsage;
			for index, subcmdUsage in UNI_UNITARGETUSAGE_SUBCMD do
				if (subcmdUsage) then
					UniTar_ChatPrint(subcmdUsage);
				end
			end
	elseif (cmd == "status") then
		local StatusStyle = "";
		local StatusGuild = "";
		local StatusRace = "";
		local StatusLocation = "";
		local StatusPVP = "";
		local StatusClass = "";
		local StatusButton = "";
		local StatusButtonTooltips = "";
		if (UniTargetSaved.Style == 1) then
			StatusStyle = "Verbose";
		elseif (UniTargetSaved.Style == 2) then
			StatusStyle = "Brief";
		end
		if (UniTargetSaved.Guild == 1) then
			StatusGuild = "On";
		elseif (UniTargetSaved.Style == 0) then
			StatusGuild = "Off";
		end
		if (UniTargetSaved.Race == 1) then
			StatusRace = "On";
		elseif (UniTargetSaved.Race == 0) then
			StatusRace = "Off";
		end
		if (UniTargetSaved.Location == 1) then
			StatusLocation = "On";
		elseif (UniTargetSaved.Location == 0) then
			StatusLocation = "Off";
		end
		if (UniTargetSaved.PVPReport == 1) then
			StatusPVP = "On";
		elseif (UniTargetSaved.PVPReport == 0) then
			StatusPVP = "Off";
		end
		if (UniTargetSaved.Class == 1) then
			StatusClass = "On";
		elseif (UniTargetSaved.Class == 0) then
			StatusClass = "Off";
		end
		if (UniTargetSaved.Button == 1) then
			StatusButton = "Shown";
		elseif (UniTargetSaved.Button == 0) then
			StatusButton = "Hidden";
		end
		if (UniTargetSaved.ButtonTooltips == 1) then
			StatusButtonTooltips = "Shown";
		elseif (UniTargetSaved.ButtonTooltips == 0) then
			StatusButtonTooltips = "Hidden";
		end
		UniTar_ChatPrint("Current Settings for UniTarget Mod: (may need to configure em at first)");
		UniTar_ChatPrint("Style: "..StatusStyle);
		UniTar_ChatPrint("Guild: "..StatusGuild);
		UniTar_ChatPrint("Race: "..StatusRace);
		UniTar_ChatPrint("Location: "..StatusLocation);
		UniTar_ChatPrint("PVP: "..StatusPVP);
		UniTar_ChatPrint("Class: "..StatusClass);
		UniTar_ChatPrint("Channel: "..UniTargetSaved.Channel);
		UniTar_ChatPrint("Button: "..StatusButton);
		UniTar_ChatPrint("Button Tooltips: "..StatusButtonTooltips);
	elseif (cmd == "default") then
		UTDefaultConfig();
	elseif (cmd == "config") then
		if(UniTargetConfigFrame:IsVisible()) then
			UniTargetConfigFrame:Hide();
		else
			UniTargetConfigFrame:Show();
		end
	elseif (cmd == "channel") then
		if (param) then
			UniTar_Chan_Name = UniTar_GetChannelName(param)
			if (UniTar_Chan_Name == -1) then	-- not a valid channel
				UniTar_ChatPrint(">");
				local index, subcmdUsage;
				for index, subcmdUsage in UNI_UNITARGETUSAGE_SUBCMD do
					if (subcmdUsage) then
						UniTar_ChatPrint(subcmdUsage);
					end
				end
			elseif (UniTar_Chan_Name == 0) then
			UniTar_ChatPrint("Channel does not exist.");
			else
			UniTar_ChatPrint(UniTar_Chan_Name.." channel selected.");
			end
		end
	elseif (cmd == "target") then
		if (param) then
			if ( param == "party" ) then
				UniTarget_OnKeypressOne();
				return;
			elseif ( param == "guild" ) then
				UniTarget_OnKeypressTwo();
				return;
			elseif ( param == "officer" ) then
				UniTarget_OnKeypressThree();
				return;
			elseif ( param == "self" ) then
				UniTarget_OnKeypressFour();
				return;
			elseif ( param == "raid" ) then
				UniTarget_OnKeypressFive();
				return;
			else
				UniTar_ChatPrint(">");
				local index, subcmdUsage;
				for index, subcmdUsage in UNI_UNITARGET_SUBCMD do
				if (subcmdUsage) then
					UniTar_ChatPrint(subcmdUsage);
				end
				end
			end
		else
			UniTar_ChatPrint(">");
			local index, subcmdUsage;
			for index, subcmdUsage in UNI_UNITARGET_SUBCMD do
			if (subcmdUsage) then
				UniTar_ChatPrint(subcmdUsage);
			end
			end
		end
	elseif ( cmd == "style" ) then
		if not (param) then
			if (UniTargetSaved.Style == 1) then
				UniTargetSaved.Style = 2;
				UniTar_ChatPrint("UniTarget set to Brief Style.");
			else
				UniTargetSaved.Style = 1;
				UniTar_ChatPrint("UniTarget set to Verbose Style.");
			end
		elseif (param == "brief") then
			UniTargetSaved.Style = 2;
			UniTar_ChatPrint("UniTarget set to Brief Style.");
		elseif (param == "verbose") then
			UniTargetSaved.Style = 1;
			UniTar_ChatPrint("Unitarget set to Verbose Style.");
		else
			if (UniTargetSaved.Style == 1) then
				UniTargetSaved.Style = 2;
				UniTar_ChatPrint("UniTarget set to Brief Style.");
			else
				UniTargetSaved.Style = 1;
				UniTar_ChatPrint("UniTarget set to Verbose Style.");
			end
		end
	elseif ( cmd == "guild" ) then
		if not (param) then
			if (UniTargetSaved.Guild == 1) then
				UniTargetSaved.Guild = 0;
				UniTar_ChatPrint("UniTarget Guild reporting off.");
			else
				UniTargetSaved.Guild = 1;
				UniTar_ChatPrint("UniTarget Guild reporting on.");
			end
		elseif (param == "on") then
			UniTargetSaved.Guild = 1;
			UniTar_ChatPrint("UniTarget Guild reporting on.");
		elseif (param == "off") then
			UniTargetSaved.Guild = 0;
			UniTar_ChatPrint("Unitarget Guild reporting off.");
		else
			if (UniTargetSaved.Guild == 1) then
				UniTargetSaved.Guild = 0;
				UniTar_ChatPrint("UniTarget Guild reporting off.");
			else
				UniTargetSaved.Guild = 1;
				UniTar_ChatPrint("UniTarget Guild reporting on.");
			end
		end
	elseif ( cmd == "race" ) then
		if not (param) then
			if (UniTargetSaved.Race == 1) then
				UniTargetSaved.Race = 0;
				UniTar_ChatPrint("UniTarget Race reporting off.");
			else
				UniTargetSaved.Race = 1;
				UniTar_ChatPrint("UniTarget Race reporting on.");
			end
		elseif (param == "on") then
			UniTargetSaved.Race = 1;
			UniTar_ChatPrint("UniTarget Race reporting on.");
		elseif (param == "off") then
			UniTargetSaved.Race = 0;
			UniTar_ChatPrint("Unitarget Race reporting off.");
		else
			if (UniTargetSaved.Race == 1) then
				UniTargetSaved.Race = 0;
				UniTar_ChatPrint("UniTarget Race reporting off.");
			else
				UniTargetSaved.Race = 1;
				UniTar_ChatPrint("UniTarget Race reporting on.");
			end
		end
	elseif ( cmd == "location" ) then
		if not (param) then
			if (UniTargetSaved.Location == 1) then
				UniTargetSaved.Location = 0;
				UniTar_ChatPrint("UniTarget Location reporting off.");
			else
				UniTargetSaved.Location = 1;
				UniTar_ChatPrint("UniTarget Location reporting on.");
			end
		elseif (param == "on") then
			UniTargetSaved.Location = 1;
			UniTar_ChatPrint("UniTarget Location reporting on.");
		elseif (param == "off") then
			UniTargetSaved.Location = 0;
			UniTar_ChatPrint("Unitarget Location reporting off.");
		else
			if (UniTargetSaved.Location == 1) then
				UniTargetSaved.Location = 0;
				UniTar_ChatPrint("UniTarget Location reporting off.");
			else
				UniTargetSaved.Location = 1;
				UniTar_ChatPrint("UniTarget Location reporting on.");
			end
		end
	elseif ( cmd == "class" ) then
		if not (param) then
			if (UniTargetSaved.Class == 1) then
				UniTargetSaved.Class = 0;
				UniTar_ChatPrint("UniTarget Classreporting off.");
			else
				UniTargetSaved.Class = 1;
				UniTar_ChatPrint("UniTarget Class reporting on.");
			end
		elseif (param == "on") then
			UniTargetSaved.Class = 1;
			UniTar_ChatPrint("UniTarget Class reporting on.");
		elseif (param == "off") then
			UniTargetSaved.Class = 0;
			UniTar_ChatPrint("Unitarget Class reporting off.");
		else
			if (UniTargetSaved.Class == 1) then
				UniTargetSaved.Class = 0;
				UniTar_ChatPrint("UniTarget Class reporting off.");
			else
				UniTargetSaved.Class = 1;
				UniTar_ChatPrint("UniTarget Class reporting on.");
			end
		end
	elseif ( cmd == "pvp" ) then
		if not (param) then
			if (UniTargetSaved.PVPReport == 1) then
				UniTargetSaved.PVPReport = 0;
				UniTar_ChatPrint("UniTarget PvP reporting off.");
			else
				UniTargetSaved.PVPReport = 1;
				UniTar_ChatPrint("UniTarget PvP reporting on.");
			end
		elseif (param == "on") then
			UniTargetSaved.PVPReport = 1;
			UniTar_ChatPrint("UniTarget PvP reporting on.");
		elseif (param == "off") then
			UniTargetSaved.PVPReport = 0;
			UniTar_ChatPrint("Unitarget PvP reporting off.");
		else
			if (UniTargetSaved.PVPReport == 1) then
				UniTargetSaved.PVPReport = 0;
				UniTar_ChatPrint("UniTarget PvP reporting off.");
			else
				UniTargetSaved.PVPReport = 1;
				UniTar_ChatPrint("UniTarget PvP reporting on.");
			end
		end
	elseif (cmd == "button") then
		if (param) then
			if ( param == "show" ) then
				UniTargetFrame:Show();
				UniTargetSaved.Button = 1;
				return;
			elseif ( param == "tooltips" ) then
				if (UniTargetSaved.ButtonTooltips == 1) then
					UniTargetSaved.ButtonTooltips = 0;
					UniTar_ChatPrint("ButtonTooltips hidden.");
				elseif (UniTargetSaved.ButtonTooltips == 0) then
					UniTargetSaved.ButtonTooltips = 1;
					UniTar_ChatPrint("ButtonTooltips shown.");
				end
			elseif ( param == "hide" ) then
				UniTargetFrame:Hide();
				UniTargetSaved.Button = 0;
				return;
			elseif ( param == "status" ) then
				if (UniTargetSaved.Button == 1) then
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Uni Target Button is enabled.");
					return;
				elseif (UniTargetSaved.Button == 0) then
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Uni Target Button is disabled.");
				else
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Not sure what's going on, blame Uni (or at least tell him).");
				end
			elseif ( param == "chatprint") then
				if (UniTargetSaved.Chatprint == 1) then
					UniTargetSaved.Chatprint = 0;
					UniTar_ChatPrint("Clicks will no longer do a generic chat-printout, just in the editbox");
				else 
					if (UniTargetSaved.Chatprint == 0) or not (UniTargetSaved.Chatprint) then
						UniTargetSaved.Chatprint = 1;
						UniTar_ChatPrint("Clicks will do a generic chat-printout as well as the editbox");
					end
				end
			elseif ( param == "reset" ) then
				UniTargetButton_Reset();
				return;
			elseif ( param == "lock" ) then
				UniTargetSaved.ButtonLock = 1;
				UniTargetButtonMover:Hide();
				return;
			elseif ( param == "unlock" ) then
				UniTargetSaved.ButtonLock = 0;
				UniTargetButtonMover:Show();
				return;
			elseif ( param == "showtoggle" ) then
				if (UniTargetSaved.Button == 1) then
					UniTargetSaved.Button = 0;
					if (UniTargetFrame:IsVisible()) then
						UniTargetFrame:Hide();
					end
					UniTar_ChatPrint("UniTarget Button Hidden.");
				else
					UniTargetSaved.Button = 1;
					if (UnitName("target") ~= nil) then
						UniTargetFrame:Show();
					end
					UniTar_ChatPrint("UniTarget Button Shown.");
				end
			elseif ( param == "large" ) then
				UniTargetButton_SizeLargeSet();
			elseif ( param == "small" ) then
				UniTargetButton_SizeSmallSet();
			elseif ( param == "tiny" ) then
				UniTargetButton_SizeTinySet();
			elseif ( param == "sizetoggle" ) then
				UniTargetButton_SizeToggle();
			elseif ( param == "function" ) then
				UniTargetButton_FunctionToggle();
			else
				UniTar_ChatPrint(">");
				local index, subcmdUsage;
				for index, subcmdUsage in UNI_UNITARGETBUTTON_SUBCMD do
					if (subcmdUsage) then
						UniTar_ChatPrint(subcmdUsage);
					end
				end
			end
		else
			UniTar_ChatPrint(">");
			local index, subcmdUsage;
			for index, subcmdUsage in UNI_UNITARGETBUTTON_SUBCMD do
				if (subcmdUsage) then
					UniTar_ChatPrint(subcmdUsage);
				end
			end
		end
	else
		UniTar_ChatPrint(">");
		UniTar_ChatPrint("Either you're a muppet, or Unique is (odds are evens).");
		UniTar_ChatPrint("I don't recognise command: '"..cmd.."'");
	end
end

------------------------------------------------------------------------------------------------
-- Channel-choosing stuff
------------------------------------------------------------------------------------------------

function UniTar_GetChannelName(UTChanMsg)
	UTChanMsg = strupper(UTChanMsg)
	local UTValidChan ='|SELF|SAY|YELL|PARTY|GUILD|RAID|1|2|3|4|5|6|7|8|9|';
	local UTid=0;
	-- check if it is a valid channel
	if (string.find(UTValidChan,"|"..UTChanMsg.."|",1,true) == nil) then
		return -1;
	end
	if (string.len(UTChanMsg) > 1) then	-- SELF|SAY|YELL|PARTY|GUILD|RAID
		UniTargetSaved.Channel=UTChanMsg;
		if UniTargetConfigFrame:IsVisible() then
			UniTargetConfig_SetValues();
		end
		return UTChanMsg;
	end

	UTid,C_Name=GetChannelName(UTChanMsg);
	if (UTid ~= 0) then
		UTid="\""..C_Name.."\""; -- return channel name
		UniTargetSaved.Channel=UTChanMsg;
		if UniTargetConfigFrame:IsVisible() then
			UniTargetConfig_SetValues();
		end
	end
	return UTid;
end

------------------------------------------------------------------------------------------------
-- Button Showing, Moving, Locking & OnClick Text
------------------------------------------------------------------------------------------------

function UniTargetButton_OnLoad()
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("VARIABLES_LOADED");
end

function UniTargetButton_OnEvent()
	if (event == "PLAYER_TARGET_CHANGED") then
		if ((UniTargetSaved.Button == 1) and (UnitName("target") ~= nil)) then
			UniTargetFrame:Show();
			if (UniTargetSaved.ButtonSize == "small") then
				UniTargetButton_SizeSmallSet();
			elseif (UniTargetSaved.ButtonSize == "tiny") then
				UniTargetButton_SizeTinySet();
			end
		else
			UniTargetFrame:Hide();
		end
	end
	if (event == "VARIABLES_LOADED") then
		if (UnitName("target") ~= nil) then
			UniTargetFrame:Hide();
		end
	end
end

function UniTargetButton_Reset()
	if (UniTargetSaved.Button == 1) then
		UniTargetFrame:ClearAllPoints();
		UniTargetFrame:SetPoint("TOPLEFT","UIParent","TOPLEFT",480,-65);
		UniTargetButtonMover:SetPoint("BOTTOMRIGHT","UniTargetFrame", "TOPLEFT",0,0);
		UniTargetButtonButton:SetPoint("TOPLEFT","UniTargetFrame","BOTTOMRIGHT",-5,5);
		UniTargetSaved.ButtonLocked = 1;
		UniTargetButton_SizeLargeSet();
		if (UnitName("target")) then
			UniTargetFrame:Show();
		else
			UniTargetFrame:Hide();
		end
	end 	
end

function UniTargetButton_SizeSmallSet()
	if (UniTargetSaved ~= nil) then
		UniTargetButtonButton:SetScale(UIParent:GetScale() * UniTargetButtonSizeSmall);
		UniTargetSaved.ButtonSize = "small";
	end
end

function UniTargetButton_SizeTinySet()
	if (UniTargetSaved ~= nil) then
		UniTargetButtonButton:SetScale(UIParent:GetScale() * UniTargetButtonSizeTiny);
		UniTargetSaved.ButtonSize = "tiny";
	end
end

function UniTargetButton_SizeLargeSet()
	if (UniTargetSaved ~= nil) then
		UniTargetButtonButton:SetScale(UIParent:GetScale());
		UniTargetSaved.ButtonSize = "large";
	end
end

function UniTargetButton_FunctionToggle()
	if (UniTargetSaved ~= nil) then
		if (UniTargetSaved.ButtonFunction == 1) then
			UniTargetSaved.ButtonFunction = 2;
			UniTar_ChatPrint("Button Function - Left button primary, Right button edit-box.");
		elseif (UniTargetSaved.ButtonFunction == 2) then
			UniTargetSaved.ButtonFunction = 1;
			UniTar_ChatPrint("Button Function - Right button primary, Left button edit-box.");
		end
	end
end

function UniTargetButton_SizeToggle()
	if (UniTargetSaved ~= nil) then
		if (UniTargetSaved.ButtonSize == "large") then
			UniTargetButton_SizeSmallSet();
		elseif (UniTargetSaved.ButtonSize == "small") then
			UniTargetButton_SizeTinySet();
		else
			UniTargetButton_SizeLargeSet();
		end
	end
end

function UniTargetButton_OnEnter()
	if (UniTargetSaved.ButtonTooltips == 1) then
		GameTooltip:SetOwner(this, "ANCHOR_LEFT");
		if (UniTargetSaved.ButtonLock == 0) then
			GameTooltip:SetText("Left button drags frame around", 1.0, 1.0, 1.0);
			GameTooltip:AddLine("Other UniTarget functions disabled till button locked.", 1.0, 1.0, 1.0);
			GameTooltip:AddLine("Shift right-click to lock.", 1.0, 1.0, 1.0);
		else
			if (UniTargetSaved.ButtonFunction == 1) then
				GameTooltip:SetText("Left-Click to insert Target-info into chat edit-box", 1.0, 1.0, 1.0);
				if (UniTargetSaved.Channel ~= nil) then
					if ((UniTargetSaved.Channel == "RAID") or (UniTargetSaved.Channel == "GUILD") or (UniTargetSaved.Channel == "PARTY") or (UniTargetSaved.Channel == "YELL") or (UniTargetSaved.Channel == "SAY")) then
						GameTooltip:AddLine("Right-Click to insert Target-info to "..UniTargetSaved.Channel.." channel.",1.0, 1.0, 1.0);
					elseif (UniTargetSaved.Channel == "SELF") then
						GameTooltip:AddLine("Right-Click to insert Target-info to Self.",1.0, 1.0, 1.0);
					elseif ( strlen(UniTargetSaved.Channel) == 1) then
						GameTooltip:AddLine("Right-Click to insert Target-info to channel number: "..UniTargetSaved.Channel ,1.0, 1.0, 1.0);
					else
						GameTooltip:AddLine("Use \'/ut channel\' to setup what Right-Click does.",1.0, 1.0, 1.0);
					end
				else
					GameTooltip:AddLine("Use \'/ut channel\' to setup what Right-Click does.",1.0, 1.0, 1.0);
				end
			else
				if (UniTargetSaved.Channel ~= nil) then
					if ((UniTargetSaved.Channel == "RAID") or (UniTargetSaved.Channel == "GUILD") or (UniTargetSaved.Channel == "PARTY") or (UniTargetSaved.Channel == "YELL") or (UniTargetSaved.Channel == "SAY")) then
						GameTooltip:SetText("Left-Click to insert Target-info to "..UniTargetSaved.Channel.." channel.",1.0, 1.0, 1.0);
					elseif (UniTargetSaved.Channel == "SELF") then
						GameTooltip:SetText("Left-Click to insert Target-info to Self.",1.0, 1.0, 1.0);
					elseif ( strlen(UniTargetSaved.Channel) == 1) then
						GameTooltip:SetText("Left-Click to insert Target-info to channel number: "..UniTargetSaved.Channel ,1.0, 1.0, 1.0);
					else
						GameTooltip:SetText("Use \'/ut channel\' to setup what Left-Click does.",1.0, 1.0, 1.0);
					end
				else
					GameTooltip:SetText("Use \'/ut channel\' to setup what Left-Click does.",1.0, 1.0, 1.0);
				end
				GameTooltip:AddLine("Right-Click to insert Target-info into chat edit-box", 1.0, 1.0, 1.0);
			end
			GameTooltip:AddLine("Shift-Right-click to Unlock", "", 1, 1, 1);
		end
		GameTooltip:Show();
	end
end

function UniTargetSetupMessage()
	if (UnitName("target") ~= nil) then
		local UniTarHealth = UnitHealth("target");
		local UniTarName = UnitName("target");
		local UniTarColName = UnitName("target");
		local UniTarLvl = 0;
		local UniTarClass = UnitClass("target");
		local UniTarRace = 0;
		local UniTarPVPName = 0;
		local UniTarGuild = GetGuildInfo("target");
		local UniTarLocationMsg = "";
		local UniTarLocationX,UniTarLocationY = GetPlayerMapPosition("player");
		if ( UnitIsPlayer("target") ~= nil) then
			if (UnitName("target") == UnitName("player")) or (UnitInParty("target")) or (UnitInRaid("target")) then
			UniTarLocationX,UniTarLocationY = GetPlayerMapPosition("target");
			end
		end
		local UniTarPVPTagMsg = "";
		local UniSubZone=GetSubZoneText();
		local UniMainZone=GetZoneText();
		UniTarLocationX=floor(UniTarLocationX*100);
		UniTarLocationY=floor(UniTarLocationY*100);
		local LocMsg = "";
		if (UniTarLocationX==0 and UniTarLocationY==0) then
			UniTarLocationMsg = format("unknown loc in"..UniSubZone);
		else
			if (strlen(UniSubZone) > 1) then
				UniTarLocationMsg = format("("..UniTarLocationX..","..UniTarLocationY..") in "..UniSubZone);
			else
				UniTarLocationMsg = format("("..UniTarLocationX..","..UniTarLocationY..") in "..UniMainZone);
			end
		end
		if ( UnitLevel("target") == -1 ) then
			UniTarLvl = "??";
		else
			UniTarLvl = UnitLevel("target");
		end
		if ( UnitClassification("target") == "elite") then
			if (UniTargetSaved.Style == 1) then
				UniTarLvl = format(UniTarLvl.." (Elite)");
			elseif (UniTargetSaved.Style == 2) then
				UniTarLvl = format(UniTarLvl.."(E)");
			end
		elseif ( UnitClassification("target") == "rareelite") then
			if (UniTargetSaved.Style == 1) then
				UniTarLvl = format(UniTarLvl.." (RareElite)");
			elseif (UniTargetSaved.Style == 2) then
				UniTarLvl = format(UniTarLvl.."(E+)");
			end
		elseif ( UnitClassification("target") == "rare") then
			if (UniTargetSaved.Style == 1) then
				UniTarLvl = format(UniTarLvl.." (Rare)");
			elseif (UniTargetSaved.Style == 2) then
				UniTarLvl = format(UniTarLvl.."(R)");
			end
		end
		if (UnitRace("target") ~= nil ) then
			UniTarRace = UnitRace("target");
		else
			if (UniTargetSaved.Style == 1) then
				UniTarRace = "(Race Unknown)";
			elseif (UniTargetSaved.Style == 2) then
				UniTarRace = "";
			end
		end
		if (UnitHealthMax("target") ~= 100) then
			UniTarHealth = floor(100*UnitHealth("target")/UnitHealthMax("target"));
		end
		if (UnitIsPVP("target")) then
			UniTarPVPTagMsg = "[PvP: ON]";
		else
			UniTarPVPTagMsg = "[PvP: OFF]";
		end
		
		-- Constructing the message (style 1 = verbose, style 2 = brief)
		UniTarMessage = "Target: ";
		if (UniTargetSaved.Style == 1) then
			if ((UniTargetSaved.Guild == 1) and ( GetGuildInfo("target") ~= nil )) then
				UniTarName = UniTarName.." of the guild \'"..GetGuildInfo("target").."\'";
			end
			UniTarMessage = UniTarMessage..UniTarName;
			if ((UniTargetSaved.PVPReport == 1) and (UnitPVPRank("target") > 0 )) then
				UniTarPVPName = GetPVPRankInfo(UnitPVPRank("target"));
				UniTarMessage = UniTarMessage..", PVP Rank: "..UniTarPVPName;
			end

			UniTarMessage = UniTarMessage.." (Lvl: "..UniTarLvl;
			if (UniTargetSaved.Race == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarRace;
			end
			if (UniTargetSaved.Class == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarClass;
			end
			UniTarMessage = UniTarMessage.." "..UniTarHealth.."% Health)";
			if (UniTargetSaved.Location == 1) then
				UniTarMessage = UniTarMessage.." at loc "..UniTarLocationMsg;
			end
			if (UniTargetSaved.PVPReport == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarPVPTagMsg;
			end
		elseif (UniTargetSaved.Style == 2) then
			if ((UniTargetSaved.PVPReport == 1) and (UnitPVPRank("target") > 0)) then
				UniTarPVPName = GetPVPRankInfo(UnitPVPRank("target"));
				UniTarMessage = UniTarMessage..UniTarPVPName.." ";
			end
			UniTarMessage = UniTarMessage..UniTarName;
			if ((UniTargetSaved.Guild == 1) and ( GetGuildInfo("target") ~= nil )) then
				UniTarMessage = UniTarMessage.." <"..GetGuildInfo("target")..">";
			end
			UniTarMessage = UniTarMessage.." "..UniTarLvl;
			if (UniTargetSaved.Race == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarRace;
			end
			if (UniTargetSaved.Class == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarClass;
			end
			UniTarMessage = UniTarMessage.." "..UniTarHealth.."%";
			if (UniTargetSaved.Location == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarLocationMsg;
			end
			if (UniTargetSaved.PVPReport == 1) then
				UniTarMessage = UniTarMessage.." "..UniTarPVPTagMsg;
			end
		else
			UniTar_ChatPrint("Unable to detect Style - type \'|cffffffff/ut style|r\' to set one.");
		end
	end
end

function UniTargetButton_OnClick(button)
	if (UniTargetSaved.ButtonFunction == 2) then
		if (button == "RightButton") then
			if (UnitName("target") ~= nil) then
				UniTargetSetupMessage();
				ChatFrameEditBox:Insert(UniTarMessage);
				if (UniTargetSaved.Chatprint == 1) then
					UniTar_ChatPrint(UniTarMessage);
				else
				end
			end			
		elseif (button == "LeftButton") then
			if (UnitName("target") ~= nil) then
				UniTargetCustomiseableChannelMessage();
			end
		end
	else
		if (button == "LeftButton") then
			if (UnitName("target") ~= nil) then
				UniTargetSetupMessage();
				ChatFrameEditBox:Insert(UniTarMessage);
				if (UniTargetSaved.Chatprint == 1) then
					UniTar_ChatPrint(UniTarMessage);
				else
				end
			end			
		elseif (button == "RightButton") then
			if (UnitName("target") ~= nil) then
				UniTargetCustomiseableChannelMessage();
			end
		end
	end
end

function UniTargetCustomiseableChannelMessage()
	if (UniTargetSaved.Channel == "SELF") then
		UniTargetSetupMessage();
		UniTar_ChatPrint(UniTarMessage)
	elseif ((UniTargetSaved.Channel == "RAID") or (UniTargetSaved.Channel == "GUILD") or (UniTargetSaved.Channel == "PARTY") or (UniTargetSaved.Channel == "YELL") or (UniTargetSaved.Channel == "SAY")) then
		UniTargetSetupMessage();
		UniTar_ChannelMessage(UniTarMessage,UniTargetSaved.Channel);
	elseif ( strlen(UniTargetSaved.Channel) == 1) then
		UniTargetSetupMessage()
		SendChatMessage(UniTarMessage,"CHANNEL",UTLang,UniTargetSaved.Channel);
	else
		UniTargetSetupMessage()
		UniTar_ChatPrint("shouldn't get here - ChannelName should be invalid ("..UniTargetSaved.Channel..")");
		UniTar_ChannelMessage(UniTarMessage,UniTargetSaved.Channel);
	end
end

------------------------------------------------------------------------------------------------
-- Message-processing function to make my life easier :P
------------------------------------------------------------------------------------------------

function UniTar_ChannelMessage(message, channel)
	SendChatMessage(message, channel);
end

function UniTar_ChatPrint(str)
	if ( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage(str, 1.0, 0.5, 0.25);
	end
end

------------------------------------------------------------------------------------------------
-- Keybind Text
------------------------------------------------------------------------------------------------

function UniTarget_OnKeypressOne()	-- Party keybind
	if (UnitName("target") ~= nil) then
		UniTargetSetupMessage();
		UniTar_ChannelMessage(UniTarMessage, PARTY);
	end
end

function UniTarget_OnKeypressTwo()	-- Guild keybind
	if (UnitName("target") ~= nil) then
		UniTargetSetupMessage();
		UniTar_ChannelMessage(UniTarMessage, GUILD);
	end
end

function UniTarget_OnKeypressThree()	-- Officer keybind
	if (UnitName("target") ~= nil) then
		UniTargetSetupMessage();
		UniTar_ChannelMessage(UniTarMessage, "OFFICER");
	end
end

function UniTarget_OnKeypressFour()	-- Self keybind
	if (UnitName("target") ~= nil) then
		UniTargetSetupMessage();
		UniTar_ChatPrint(UniTarMessage);
	end
end

function UniTarget_OnKeypressFive()	-- Raid keybind
	if (UnitName("target") ~= nil) then
		UniTargetSetupMessage();
		UniTar_ChannelMessage(UniTarMessage, RAID);
	end
end

function UniTarget_OnKeypressSix()	-- Customisable keybind
	if (UnitName("target") ~= nil) then
		UniTargetCustomiseableChannelMessage();
	end
end